//
//  LKKeychainAssistant.h
//  LicenceKit - https://indie.miln.eu
//
//  Copyright © Graham Miln. All rights reserved. https://miln.eu
//
//  This package is subject to the terms of the Artistic License 2.0.
//  If a copy of the Artistic-2.0 was not distributed with this file, you can
//  obtain one at https://indie.miln.eu/licence

@import Cocoa;
@import LicenceCore;

// Info.plist keys
extern NSString* LKLicenceKitInfoPListKeySubjectPrefixes; /**< Info.plist "LKSubjectPrefixes" : An array of certificate subject prefix strings to match; optional, see @property subjectPrefixes */

@interface LKKeychainAssistant : NSObject
@property(copy,readwrite) NSArray<NSString*>* subjectPrefixes; /** Certificate subject prefix strings to match when searching the Keychain. If nil or empty, LKLicenceKitInfoPListKeySubjectPrefixes will be used. */

- (instancetype)init;
- (instancetype)initWithCore:(LCLicenceCore*)aCore;

/** Add matching licence certificates found in Keychain. */
- (void)addLicences;

/** Remove matching licence certificates from the Keychain. */
- (NSError*)removeLicencesFromKeychain;

@end
